!     INCLUDE FILE IP DATA BDB
MODULE INPPARAMS
USE DBNULL

IMPLICIT NONE
INTEGER, PARAMETER :: MAXFLDS=100                        !MAX FLDS IN DATABASE
INTEGER, PARAMETER :: MAXHARR=372                        !MAXIMUM NUMERIC HEADER VALUES
INTEGER, PARAMETER :: MAXTIMES=MAXFLDS-10                !MAXIMUM NUMBER OF WINDOW TIMES ALLOWED
INTEGER :: LUHPRT                                        !HANDLE FOR PRT FILE
REAL,DIMENSION(MAXFLDS) :: ZDATA                         !ARRAY FOR 1 RECORD
REAL,DIMENSION(MAXFLDS) :: ZMIN                          !ARRAY MINS FOR EACH RECORD
REAL,DIMENSION(MAXFLDS) :: ZMAX                          !ARRAY MAX FOR EACH RECORD
REAL, DIMENSION(MAXHARR) :: HARR = ZNULL                 !ARRAY OF NUMERIC VARIABLES IN HEADER 
REAL, DIMENSION(MAXTIMES) :: WTIME                       !ARRAY FOR WINDOW TIMES FOR TIME DOMAIN
LOGICAL(KIND=1) :: LSORT = .FALSE.                       !FLAG IF DATABASE IS SORTED 
LOGICAL(KIND=1), DIMENSION(MAXFLDS) :: LTYPE =.TRUE.     !FLAG FOR NUMERIC/CHARACTER FIELD TYPE 
CHARACTER(LEN=12), DIMENSION(MAXFLDS) :: LABEL = 'UNLABELED ' !ARRAY OF FIELD LABELS
CHARACTER(LEN=12), PARAMETER :: LABUSEFLAG = 'USE_FLAG    ' ! FIXED LABEL FOR USE FLAG
CHARACTER(LEN=40), DIMENSION(14) :: HSTR = ''             !ARRAY OF CHARACTER VARIABLES FOR HEADER
INTEGER :: LUHOUT,NFLD,NPTS,NHARM,LOCX,LOCY,NWIN          !HANDLE FOR OUTPUT FILE, NUMBER OF FIELDS AND NUMBER OF POINTS IN DATABASE, # OF HARMINICS IF CR, LOCATION OF X AND Y AND NUMBER OF WINDOWS IN TDIP
INTEGER, PARAMETER :: NSURVTYPES = 12
CHARACTER(LEN=20),DIMENSION(NSURVTYPES), PARAMETER :: SURVEYTYPES = &
     &(/'GRADIENT            ','DIPOLE-DIPOLE       ','POLE-DIPOLE         ','DIPOLE-POLE         ', &
     &'POLE-POLE           ','SCHLUMBERGER        ','WENNER              ','OFFSET-POLE-DIPOLE  ',&
     &'OFFSET-DIPOLE-DIPOLE','VECTOR IP           ','TENSOR IP           ','MIXED ARRAY         '/)

INTEGER, PARAMETER :: NIPUNITS = 3
CHARACTER(LEN=4), DIMENSION(NIPUNITS), PARAMETER :: UNITSIP = (/'mV/V','mRad','pfe '/)
!
!     SET NORMAL FIELDS FOR IP DATABASE
!
INTEGER, PARAMETER :: ILINE=1        ! line number
INTEGER, PARAMETER :: ISTAT=2        ! station
INTEGER, PARAMETER :: IEAST=3        ! easting
INTEGER, PARAMETER :: INRTH=4        ! northing
INTEGER, PARAMETER :: IELEV=5        ! rl
INTEGER, PARAMETER :: INVAL=6        ! n value
INTEGER, PARAMETER :: ICURR=7        ! current
INTEGER, PARAMETER :: IPVOL=8        ! primary voltage
INTEGER, PARAMETER :: IARHO=9        ! resistivity
INTEGER, PARAMETER :: ICHPH=10       ! IP (chargeability/phase)
LOGICAL :: LZONGE                    ! FLAG FOR ZONGE GDP DATA - GETS WINDOW TIMES
LOGICAL :: LTDOMAIN                  ! FLAG FOR TIME DOMAIN - EFFECTS LABELS
LOGICAL :: LDHOLE                    ! FLAG FOR CROSS HOLE SURVEYS WHICH NEED MORE FIELDS IN BDB
LOGICAL :: LSPECTRAL                 ! FLAG FOR SPECTRAL IP ie MULTPILE WINDOWS OR FREQUENCIES


INTERFACE LNULL
  ELEMENTAL LOGICAL FUNCTION LNULL(Z1,Z2,Z3,Z4,Z5)        ! DETERMINES WHETHER A FIELD VALUE IS NULL OR NOT
  REAL, INTENT(IN) :: Z1
  REAL, OPTIONAL, INTENT(IN) :: Z2
  REAL, OPTIONAL, INTENT(IN) :: Z3
  REAL, OPTIONAL, INTENT(IN) :: Z4
  REAL, OPTIONAL, INTENT(IN) :: Z5
  END FUNCTION LNULL
END INTERFACE

END MODULE





